# IBM Aspera

#### Overview

The Veza integration for IBM Aspera on Cloud enables gathering User, Groups, Roles and Workspace memberships for the cloud-based file transfer platform.

#### Configuring Aspera

1. Generate a key pair to use for authentication (if creating a new user):
   1. Use the command to generate the private portion `ssh-keygen -t rsa -b 4096 -m PEM -f jwtRS256.key`.
   2. Do not set a password.
   3. Create a public key from the private key: `openssl rsa -in jwtRS256.key -pubout -outform PEM -out jwtRS256.key.pub`.
2. Create or use an existing user for authentication:
   1. For a new user, set the user's public key to the public portion of the generated key pair.
   2. For an existing user and key pair set, use the corresponding public key to configure the integration in Veza.
3. Go to **Integrations -> API clients** to create an API client:
   1. Enter a name.
   2. Enter the Veza URL for the Redirect URI.
   3. Enable **Enable JWT Grant type**.
   4. Deselect **Client can retrieve token for all users** and pick the configured user.
   5. Click create and note the **Client ID** and **Client Secret**
4. Note the Aspera Organization name. This is your Aspera sub-domain, for example `https://<org_name>.ibmaspera.com`.

#### Configuring Aspera on the Veza Platform

1. On the Veza **Integrations** page, add a **Aspera** Integration with the following fields:
   1. **Name** - Name for integration
   2. **Client Id** - Client ID from the API client
   3. **Client Secret** - Corresponding Client Secret
   4. **Username** - Username for API client user with public key.
   5. **Organization Name** - Aspera Organization name

#### Notes and Supported Entities

**Aspera Users**

| Attribute            | Notes                                      |
| -------------------- | ------------------------------------------ |
| `id`                 | Aspera on Cloud User ID                    |
| `name`               | User full name as configured               |
| `is_active`          | Boolean True if user is active             |
| `created_at`         | Timestamp for user creation                |
| `last_login_at`      | Timestamp user last logged in              |
| `email`              | User's configured email                    |
| `ibm_uid`            | Corresponding IBM User ID                  |
| `ats_admin`          | Boolean true if user is ATS Admin          |
| `organization_admin` | Boolean True if user is Organization Admin |

**Aspera Group**

| Attribute     | Notes                              |
| ------------- | ---------------------------------- |
| `id`          | Aspera Group ID                    |
| `name`        | Group name                         |
| `created_at`  | Timestamp for group creation       |
| `manager_ids` | List of manager User IDs for Group |
| `owner_ids`   | List of group owner IDs            |

**Aspera Workspace**

| Attribute     | Notes                 |
| ------------- | --------------------- |
| `id`          | Workspace ID          |
| `name`        | Workspace Name        |
| `description` | Workspace description |

**Aspera Roles**

Users are assigned roles to the Organization and Workspace based on their configured status

**Organization Roles**

* Organization Admin
* ATS Admin
* Member

**Workspace Roles**

* Manager
* Member


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.veza.com/4yItIzMvkpAvMVFAamTf/integrations/integrations/aspera.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
